package de.ard.swr.soa.bpm_soap;

import java.io.StringReader;

import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMResult;
import javax.xml.transform.stream.StreamSource;

import org.switchyard.annotations.Transformer;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

public class Transformers {
	
	@Transformer(from = "{http://imexmock.esb.swr.ard.de/}testResponse")
	public Integer transform(Element from) {
		return Integer.parseInt(getElementValue(from, "return"));
	}
	
	@Transformer(from = "{http://imexmock.esb.swr.ard.de/}test")
	public String transformTest(Element from) {
		return "";
	}
	
	@Transformer(to = "{http://imexmock.esb.swr.ard.de/}testResponse")
	public Element transformToElement(Integer retVal) {
		StringBuilder ackXml = new StringBuilder()
		.append("<ns2:testResponse xmlns:ns2=\"http://imexmock.esb.swr.ard.de/\">")
		.append(        "<result>" + retVal + "</result>")
		.append("</ns2:testResponse>");
		return toElement(ackXml.toString());
	}
	
	@Transformer(to = "{http://imexmock.esb.swr.ard.de/}test")
	public Element transformVoidToElement(Object obj) {
		StringBuilder ackXml = new StringBuilder()
		.append("<imex:test/>");
		return toElement(ackXml.toString());
	}
	
    private String getElementValue(Element parent, String elementName) {
        String value = null;
        NodeList nodes = parent.getElementsByTagName(elementName);
        if (nodes.getLength() > 0) {
            value = nodes.item(0).getChildNodes().item(0).getNodeValue();
        }
        return value;
    }

    private Element toElement(String xml) {
        DOMResult dom = new DOMResult();
        try {
            TransformerFactory.newInstance().newTransformer().transform(
                    new StreamSource(new StringReader(xml)), dom);
        } catch (Exception ex) {
            ex.printStackTrace();
        }

        return ((Document)dom.getNode()).getDocumentElement();
    }
}
